﻿using System;


namespace CasinoWars
{
    class CasinoData
    {
        /*Declartion of Private Variables*/
        private string playerFirstName,
                       playerLastName,
                       playAgain;
        private double amountOfMoney,
                       amountOfBet;
        private int    playerCard,
                       dealerCard,
                       randnumb;
        private bool playerWinner;

        /*Default Constructor for CasinoData*/
        public CasinoData()
        {
        }

        /*Defined Constructor for CasinoData*/
        public CasinoData(string pfname, string plname, string pagain, double aomoney, double aobet, int pcard, int dcard, int rnum, bool pwinner)
        {
            playerFirstName = pfname;
            playerLastName = plname;
            playAgain = pagain;
            amountOfMoney = aomoney;
            amountOfBet = aobet;
            playerCard = pcard;
            dealerCard = dcard;
            randnumb = rnum;
            playerWinner = pwinner;
        }

        /*Properties for CasinoData*/

        public string pfname
        {
            get { return playerFirstName; }
            set { playerFirstName = value; }
        }
        public string plname
        {
            get { return playerLastName; }
            set { playerLastName = value; }
        }
        public string pagain
        {
            get { return playAgain; }
            set { playAgain = value; }
        }
        public double aomoney
        {
            get { return amountOfMoney; }
            set { amountOfMoney = value; }
        }
        public double aobet
        {
            get { return amountOfBet; }
            set { amountOfBet = value; }
        }
        public int pcard
        {
            get { return playerCard; }
            set { playerCard = value; }
        }
        public int dcard
        {
            get { return dealerCard; }
            set { dealerCard = value; }
        }
        public int rnum
        {
            get { return randnumb; }
            set { randnumb = value; }
        }
        public bool pwinner
        {
            get { return playerWinner; }
            set { playerWinner = value; }
        }

        /* Place your bet Method, with error controls for no data being entered*/
        public double PlaceYourBet()
        {
            string invalue;
            bool validBet = false;

            do
            {
                Console.Clear();
                Console.WriteLine();
                Console.Write("\tPlease enter your bet: ");
                invalue = Console.ReadLine();
                double tempmoney;
                bool isValidDouble = Double.TryParse((invalue), out tempmoney);
                do
                {
                    if (isValidDouble == false)
                    {
                        Console.WriteLine();
                        Console.WriteLine("\tYou must enter a Numerical Value");
                        Console.WriteLine();
                        Console.Write("\tPlease enter your bet: ");
                        invalue = Console.ReadLine();
                        isValidDouble = Double.TryParse((invalue), out tempmoney);

                    }
                }
                while (isValidDouble == false);
                aobet = tempmoney;

            }
            while (invalue == "" && aobet > 0);
            
            do
            {
                if (aobet > aomoney)
                {
                    Console.WriteLine();
                    Console.WriteLine("\tYou do not have enough cash to place that bet");
                    Console.WriteLine("\tYou have {0:C}", aomoney);
                    Console.WriteLine();
                    Console.Write("\tPlease enter your bet: ");
                    invalue = Console.ReadLine();
                    double tempmoney;
                    bool isValidDouble = Double.TryParse((invalue), out tempmoney);
                    do
                    {
                        if (isValidDouble == false)
                        {
                            Console.WriteLine();
                            Console.WriteLine("\tYou must enter a Numerical Value");
                            Console.WriteLine();
                            Console.Write("\tPlease enter your bet: ");
                            invalue = Console.ReadLine();
                            isValidDouble = Double.TryParse((invalue), out tempmoney);
                        }
                    }
                    while (isValidDouble == false);
                    aobet = tempmoney;
                }
                else
                {
                    validBet = true;
                }
            }
            while (validBet == false); 
            return aobet;
        }

        public int GeneratePlayerCard()
        {
            pcard = 0;
            Random numb = new Random();
            rnum = 0;
            rnum = numb.Next(2, 14);
            pcard = rnum; 
            return pcard;
        }

        public int GenerateDealerCard()
        {
            dcard = 0;
            Random numb2 = new Random();
            rnum = 0;
            rnum = numb2.Next(2, 14);
            dcard = rnum;
            return dcard;
        }

        public int DisplayPlayerCard()
        {
            Console.Clear();
            Console.WriteLine();
            Console.WriteLine("\t{0} you were dealt: ", playerFirstName);
            if (pcard == 14)
            {
                Console.WriteLine("\t\t\tACE");
            }
            else if (pcard == 13)
            {
                Console.WriteLine("\t\t\tKING");
            }
            else if (pcard == 12)
            {
                Console.WriteLine("\t\t\tQUEEN");
            }
            else if (pcard == 11)
            {
                Console.WriteLine("\t\t\tJACK");
            }
            else if (pcard <= 10)
            {
                Console.WriteLine("\t\t\t{0}", pcard);
            }
            Console.WriteLine();
            Console.WriteLine("\tPress Enter to See what the Computer was dealt");
            Console.ReadLine();
            return pcard;
           
        }

        public int DisplayDealerCard()
        {
            Console.WriteLine();
            Console.WriteLine("\tThe Computer was Dealt: ");
            if (dcard == 14)
            {
                Console.WriteLine("\t\t\tACE");
            }
            else if (dcard == 13)
            {
                Console.WriteLine("\t\t\tKING");
            }
            else if (dcard == 12)
            {
                Console.WriteLine("\t\t\tQUEEN");
            }
            else if (dcard == 11)
            {
                Console.WriteLine("\t\t\tJACK");
            }
            else if (dcard <= 10)
            {
                Console.WriteLine("\t\t\t{0}", dcard);
            }
            return dcard;
        }

        public bool DetermineWinner(double card1, double card2)
        {
            pwinner = false;
            int war = 0;
            
            if (pcard == dcard)
            {
                do
                {
                    if (war == 0)
                    {
                        Console.WriteLine();
                        Console.WriteLine("\tIt's a TIE!!! WE ARE GOING TO WAR!!!");
                        Console.WriteLine();
                        Console.WriteLine("\tPress Enter to See the Next Round");
                        Console.ReadLine();
                        war++;
                    }
                    else
                    {
                        Console.WriteLine();
                        Console.WriteLine("\tPress Enter to See the Next Round");
                        Console.ReadLine();
                    }
                    GeneratePlayerCard();
                    DisplayPlayerCard();
                    GenerateDealerCard();
                    DisplayDealerCard();
                    if (pcard != dcard)
                    {
                        Console.WriteLine();
                        Console.WriteLine("\tAlas, all good wars must come to an end");
                    }
                }
                while (pcard == dcard);
            }
            else if (pcard > dcard)
            {
                pwinner = true;
            }
            else
            {
                pwinner = false;
            }
            return pwinner;
        }

        public double DisplayWinnerandAdjust()
        {

            if (pwinner == true)
            {
                Console.WriteLine("\t{0} {1} has won!", pfname, plname);
                aomoney += aobet;
            }
            else
            {
                Console.WriteLine("\tThe Computer has won, bet it cheats");
                aomoney -= aobet;
            }
            Console.WriteLine("\tYou now have {0:C}", aomoney);
            return aomoney;
        }

    }
}